import 'package:flutter/widgets.dart';
import 'package:power_widget/serializable/SerializableStatefulWidget.dart';
import 'package:power_widget/serializable/SerializableWidget.dart';
import 'package:power_widget/serializable/WidgetSerializableModel.dart';

abstract class ModularizedStatefulWidget extends SerializableStatefulWidget {
  final List<SerializableStatefulWidget> widgets = new List();

  void addChildWidget(SerializableWidget child) {
    widgets.add(child);
  }

  Stack provideChildrenStack() {
    return Stack(children: provideWidgets());
  }

  List<Widget> provideWidgets() {
    return widgets.map((widget) => providePositioned(widget)).toList();
  }

  Positioned providePositioned(SerializableStatefulWidget widget) {
    WidgetSerializableModel model = widget.getWidgetSerializableModel();
    return Positioned(left: model.left, width: model.width, top: model.top, height: model.height, child: widget);
  }
}
